require 'oauth'

module Stripe2QB
  class QuickbooksApi
    class AccessToken
      include OptionsReading

      attr_reader :api_access_token
      attr_reader :api_access_secret
      attr_reader :oauth_consumer_key
      attr_reader :oauth_consumer_secret

      attr_reader :oauth

      def initialize(options = {})
        set_attribute_from_options('api_access_token', options)
        set_attribute_from_options('api_access_secret', options)
        set_attribute_from_options('oauth_consumer_key', options)
        set_attribute_from_options('oauth_consumer_secret', options)

        oauth_consumer = ::OAuth::Consumer.new(
          oauth_consumer_key,
          oauth_consumer_secret,
          {
            site: 'https://oauth.intuit.com',
            request_token_path: '/oauth/v1/get_request_token',
            authorize_url: 'https://appcenter.intuit.com/Connect/Begin',
            access_token_path: '/oauth/v1/get_access_token'
          }
        )

        @oauth = ::OAuth::AccessToken.new(oauth_consumer, api_access_token, api_access_secret)
      end
    end
  end
end
